from typing import List
from numpy import sign


##########################################
# Ukol 1
##########################################

def char_cmp(s: str) -> int:
    s = s.upper()
    counter = 0
    for znak in s:
        if znak == "A":
            counter += 1
        elif znak == "E":
            counter -= 1
    return sign(counter)


def test_char_cmp() -> None:
    print("\n*** Test char_cmp ***")
    assert char_cmp('Abeceda') == 0
    assert char_cmp('I could care less') == -1
    assert char_cmp('graham') == 1
    assert char_cmp('doge') == -1
    assert char_cmp('python') == 0


##########################################
# Ukol 2
##########################################
def christmas_tree(size: int) -> None:
    for radek in range(size):
        print((size - radek - 1) * " ", end="")
        print(radek * "X*", end="")
        print("X")
    print((size - 2) * " ", "X")
    print((size - 3) * " ", "***")


def test_christmas_tree() -> None:
    print("\n*** Test christmas_tree ***")
    # --- ocekavany vystup ---
    #   X
    #  X*X
    # X*X*X
    #   X
    #  ***
    print("vystup volani christmas_tree(3):")
    christmas_tree(3)
    # --- ocekavany vystup ---
    #       X
    #      X*X
    #     X*X*X
    #    X*X*X*X
    #   X*X*X*X*X
    #  X*X*X*X*X*X
    # X*X*X*X*X*X*X
    #       X
    #      ***
    print("vystup volani christmas_tree(7):")
    christmas_tree(7)


##########################################
# Ukol 3
##########################################
def modified_digit_sum(num: int) -> int:
    position = 0
    result = 0
    while num > 0:
        result += position + num % 10
        position += 1
        num //= 10
    return result


def test_modified_digit_sum() -> None:
    print("\n*** Test modified_digit_sum ***")
    assert modified_digit_sum(2019) == 18
    assert modified_digit_sum(42) == 7
    assert modified_digit_sum(12345) == 25


##########################################
# Ukol 4
##########################################
def letter_middle_table(size: int) -> None:
    for radek in range(size):
        vert_min = min(radek, size - radek - 1)
        for sloupec in range(size):
            horiz_min = min(sloupec, size - sloupec - 1)
                # ord("a") == 97
            print(chr(97+min(vert_min, horiz_min)), end="")
        print()


def test_letter_middle_table() -> None:
    print("\n*** Test letter_middle_table ***")
    # --- ocekavany vystup ---
    # aaaaaa
    # abbbba
    # abccba
    # abccba
    # abbbba
    # aaaaaa
    print("vystup volani letter_middle_table(6):")
    letter_middle_table(6)
    # --- ocekavany vystup ---
    # aaaaaaaaa
    # abbbbbbba
    # abcccccba
    # abcdddcba
    # abcdedcba
    # abcdddcba
    # abcccccba
    # abbbbbbba
    # aaaaaaaaa
    print("vystup volani letter_middle_table(9):")
    letter_middle_table(9)


##########################################
# Ukol 5
##########################################
# vraci 'True' pokud je 'cislo' palindrom
# pomocna funkce pro 'filter_palindromes()'
def isPal (cislo: int) -> bool:
    if cislo % 10 == 0:
        return False
    digits = []
        # zkonvertovat integer do seznamu cislic
    while cislo > 0:
        digits.append(cislo % 10)
        cislo //= 10
    length = len(digits)
        # zkontrolovat, zda je to palindrom
    for i in range(length//2):
        if digits[i] != digits[length-i-1]:
            return False
    return True


def filter_palindromes(numbers: List[int]) -> List[int]:
    result = []
    for number in numbers:
        if isPal(number):
            result.append(number)
    return result


def test_filter_palindromes() -> None:
    print("\n*** Test filter_palindromes ***")
    assert filter_palindromes([11311, 1331, 1000, 7970]) == [11311, 1331]
    assert filter_palindromes([1, 2, 5, 10, 20, 121, 77]) == [1, 2, 5, 121, 77]


##########################################
# Ukol 6
##########################################
def traffic_jam(start: str, time: int) -> List[str]:
        # konverze stringu na seznam, ktery je modifikovatelny
        # a bude se s nim lepe pracovat
    radek = list(start)
    result = []  # vystupni seznam radku
    result.append(start)
    for i in range(time-1):
        znak = "."
            # cyklus prochazi radek odleva
            # 'znak' obsahuje to, cim se ma nahradit pozice [j]
            # v dalsi iteraci cyklu pokud je volna,
            # nebo pokud se uvolni
        for j in range(len(start)-1):
            if radek[j] == ".":
                radek[j] = znak
                znak = "."
            elif radek[j+1] == ".":  # na [j] je auto a ma se kam posunout
                radek[j] = znak
                znak = "A"
            # jinak je na [j] auto, nema se kam posunout, 'znak'=="." a zustava stejny
        radek[j+1] = znak  # resi se mimo cyklus, abychom na radku 177 nesahli mimo rozsah seznamu
            # konvertovat 'radek' na retezec a pripojit do seznamu
        radek_str = ""
        radek_str = radek_str.join(radek)
        result.append(radek_str)
    return result



def test_traffic_jam() -> None:
    print("\n*** Test traffic_jam ***")
    assert traffic_jam('A..A.A..AAAA', 8) == \
        ['A..A.A..AAAA',
         '.A..A.A.AAA.',
         '..A..A.AAA.A',
         '...A..AAA.A.',
         '....A.AA.A.A',
         '.....AA.A.A.',
         '.....A.A.A.A',
         '......A.A.A.']
    assert traffic_jam('A....', 5) == \
        ['A....', '.A...', '..A..', '...A.', '....A']
    assert traffic_jam('AAAAA', 5) == \
        ['AAAAA', 'AAAA.', 'AAA.A', 'AA.A.', 'A.A.A']


##########################################
# Volani testovacich funkci
##########################################
if __name__ == '__main__':
    test_char_cmp()
    test_christmas_tree()
    test_modified_digit_sum()
    test_letter_middle_table()
    test_filter_palindromes()
    test_traffic_jam()
    pass